import os
import os.path
import threading
import time
import random
import sys
import gettext
from gi.repository import Gtk, Gdk, GObject, GLib

import signal
signal.signal(signal.SIGINT, signal.SIG_DFL)

_=gettext.gettext
gettext.textdomain('lliurex-gva')

class LliurexGVA:
	
	def __init__(self,core,msg=None):
		
		self.core=core
		self.msg=msg
		#self.start_gui()
		
		
	#def __init__
	
	def launch(self,msg):
	
		self.msg=msg	
		self.start_gui()
		GObject.threads_init()
		Gtk.main()
		
	#def launch
	
	def start_gui(self):
		
		self.build_css()
		glade_path="/usr/share/lliurex-gva/rsrc/lliurex-gva.glade"
		builder=Gtk.Builder()
		builder.set_translation_domain("lliurex-gva")
		if os.path.exists("/srv/svn/pandora/lliurex-gva/trunk/install-files/usr/share/lliurex-gva/rsrc/lliurex-gva.glade"):
			builder.add_from_file("/srv/svn/pandora/lliurex-gva/trunk/install-files/usr/share/lliurex-gva/rsrc/lliurex-gva.glade")
		else:
			builder.add_from_file(glade_path)
		
		self.window=builder.get_object("window1")
		self.window.set_name("Window1")
		self.mount_button=builder.get_object("mount_button")
		#self.mount_button.set_name("Button")
		self.close_button=builder.get_object("close_button")
		self.close_button.set_name("Button")
		self.textbuffer=builder.get_object("textbuffer")
		if self.msg!=None:
			self.textbuffer.set_text(self.msg)
		self.info_label=builder.get_object("info_label")
		self.msg_label=builder.get_object("msg_label")
		self.user_entry=builder.get_object("user_entry")
		self.pwd_entry=builder.get_object("pwd_entry")
		self.spinner=builder.get_object("spinner")

		self.user_entry.set_text(os.environ["USER"])
		self.close_button.connect("clicked",self.close_window)
		self.mount_button.connect("clicked",self.mount_clicked)
		self.window.connect("destroy",self.close_window)
		self.pwd_entry.connect("changed",self.pwd_changed)
		self.mount_button.set_sensitive(False)
	
		self.window.show_all()
		
		self.spinner.hide()		
		
		
	#def start_gui
	

	def build_css(self):
		
		css = """
		#ButtonBox {
			background-image: -gtk-gradient (linear,	left top, right top, from (rgba(255,255,255,0.6)),  to (rgba(210,210,210,0)));
		}
		
		#Window1 {
			background-image: -gtk-gradient (linear,	left top, left bottom, from (#d6fffe),  to (#ffffff));
		}
		
		#Custom{
			border-radius: 50px;
		}
		
		
		GtkButton {
		
			border-radius:50px;
		}
		
		#Button{
			background-image: -gtk-gradient (linear,	left top, left bottom, from (#f5f5f5),  to (#dedede));
			
			border-radius: 0px;
			
		}
		
		.entry{
			border-radius: 50px;
		}
		
		GtkViewport{
			
			background-image: -gtk-gradient (linear,	left top, left bottom, from (rgba(255,255,255,1)),  to (rgba(210,210,210,1)));
		}


		"""
		
		self.style_provider=Gtk.CssProvider()
		self.style_provider.load_from_data(css)
		Gtk.StyleContext.add_provider_for_screen(Gdk.Screen.get_default(),self.style_provider,Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION)
		
	#
	
	def close_window(self,widget):
		Gtk.main_quit()
		
	#def close_window
	
	def mount_clicked(self,widget):
	
		self.core.user_password=self.pwd_entry.get_text()
		#self.mount_button.set_sensitive(False)
		#self.spinner.show()
		#self.mount()
		#sys.exit(0)
		Gtk.main_quit()
		#self.close_window(None)
		
	#def mount_clicked
	
	def pwd_changed(self,widget):
		
		if len(self.pwd_entry.get_text())>0:
			self.mount_button.set_sensitive(True)
		else:
			self.mount_button.set_sensitive(False)
		
	#def pwd_changed
	
	def mount(self):
		
		t=threading.Thread(target=self._mount)
		t.daemon=True
		t.start()
		
	#def mount
	
	def _mount(self):
		
		time.sleep(2)
		if int(random.random()*10)>5:
			GLib.timeout_add(200,self.mount_done,True)
		else:
			GLib.timeout_add(200,self.mount_done,False)
		
	#def _mount
		
	def mount_done(self,status,msg=None):
		
		self.spinner.hide()
		self.mount_button.set_sensitive(True)
		
		if status:
			self.msg_label.set_markup("<b>Success!</b>")
		else:
			if msg==None:
				msg="Failed!"
			self.msg_label.set_markup("<span foreground='red'>"+msg+"</span>")
		return False
		
	#def mount_done


	
#class LliurexGVA


if __name__=="__main__":
	
	class R:
		def __init__(self):
			self.user_password=None
	
	r=R()
	
	llxgva=LliurexGVA(r,"hola que tal")
	GObject.threads_init()
	Gtk.main()
	
	print r.user_password
